/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#pragma once

#include "../JuceLibraryCode/JuceHeader.h"
#include "PluginProcessor.h"

//==============================================================================
/**
*/          //LOOK AND FEEL ROTARY KNOB
class OtherLookAndFeel : public juce::LookAndFeel_V4
{
public:
    OtherLookAndFeel()
    {
        //setColour (juce::Slider::thumbColourId, juce::Colours::red);
    }

    
    void drawRotarySlider (juce::Graphics& g, int x, int y, int width, int height, float sliderPos,
             const float rotaryStartAngle, const float rotaryEndAngle, juce::Slider&) override
    {
        auto radius = (float) juce::jmin (width / 2, height / 2) - 4.0f;
        auto centreX = (float) x + (float) width  * 0.5f;
        auto centreY = (float) y + (float) height * 0.5f;
        auto rx = centreX - radius;
        auto ry = centreY - radius;
        auto rw = radius * 2.0f;
        auto angle = rotaryStartAngle + sliderPos * (rotaryEndAngle - rotaryStartAngle);
        
        //fill
        g.setColour (juce::Colours::black);
        g.fillEllipse (rx, ry, rw, rw);
 
        // outline
        g.setColour (juce::Colours::grey);
        g.drawEllipse (rx, ry, rw, rw, 1.0f);
        
        juce::Path p;
        auto pointerLength = radius * 0.43f;
        auto pointerThickness = 5.0f;
        p.addRectangle (-pointerThickness * 0.5f, -radius, pointerThickness, pointerLength);
        p.applyTransform (juce::AffineTransform::rotation (angle).translated (centreX, centreY));
        
       //  pointer
        g.setColour (juce::Colours::white);
        g.fillPath (p);
    }



};

class C74projucerGenPluginAudioProcessorEditor  : public juce::AudioProcessorEditor, juce::Slider::Listener
{
public:
    C74projucerGenPluginAudioProcessorEditor (C74GenAudioProcessor&);
    ~C74projucerGenPluginAudioProcessorEditor();

    //==============================================================================
    void paint (juce::Graphics&) override;
    void resized() override;
    void sliderValueChanged (juce::Slider* sliderThatWasMoved) override;
    
    //juce::ScopedPointer <juce::AudioProcessorValueTreeState::SliderAttachment> sliderAttach;
    

private:
    // This reference is provided as a quick way for your editor to
    // access the processor object that created it.
    C74GenAudioProcessor& processor;
    
    OtherLookAndFeel otherLookAndFeel;
    std::unique_ptr<juce::Slider> faderSlider;
   // SmoothedValue<float, ValueSmoothingTypes::Linear> sv;
   //juce::LinearSmoothedValue<FloatType> Fader;
   
    

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (C74projucerGenPluginAudioProcessorEditor)
};
